;###############################
;#                             #
;#            2010             #
;#                             #
;#         Ray-Casting         #
;#             BY              #
;#       Hkan Ahlstrm        #
;#-----------------------------#
;#                             #
:#          CREDITS            #
;#                    #
;#         F.Permadi           #
:#           ToKeN             #
;#           Yousef            #
;#          #helpdesk          #
;#           #Math             #
;#                             #
;###############################







on *:LOAD: {
  ;frinstllda instllningar
  set %2d.zspeed 10
  set %2d.rspeed 10
  set %2d.Q 5
  set %ATTENTAT3D.2d 0
  set %att.avinst $+(",$script,")

  echo -a ATTENTAT3D
  echo -a ---------------
  echo -a Type /ATTENTAT3D or look in menubar
  echo -a 
  echo -a Thank you

  OA3D
}
on *:UNLOAD: { 
  unset %2d*
  unset %ATTENTAT3D.*
  unset %att*
  echo -a ATTENTAT 3D is now uninstalled!
}








;################################  Ladda upp allt  ###########################################

alias ATTENTAT3D.go {
  ;#Texture
  window -BCph +d @2d.tex 0 0 400 200
  drawpic @2d.tex 0 0 $+(",$scriptdirtex\vgg1.bmp,")
  drawpic @2d.tex 64 0 $+(",$scriptdirtex\vgg2.bmp,")
  drawpic @2d.tex 128 0 $+(",$scriptdirtex\vgg3.bmp,")
  drawpic @2d.tex 192 0 $+(",$scriptdirtex\vgg4.bmp,")

  ;#vgg detektor
  window -BCph +d @2d.vdet 0 0 %2d.vdet.x %2d.vdet.y
  window -BCph +d @A3D.bg 0 0 %2d.vdet.x %2d.vdet.y
  ;window -aCpd @A3D.bg 0 0 %2d.vdet.x %2d.vdet.y
  var %= $read(%2d.map, w, START)
  var %&start $calc($readn + 1)
  var %= $read(%2d.map, w, STOP)
  var %&stop $calc($readn - 1)
  var %2d.kmax $gettok($read(%2d.map, %&start), 0, 39)
  drawrect -rf @2d.vdet $rgb(0,0,0) 1 0 0 %2d.vdet.x %2d.vdet.y
  set %2d.rad %&start
  set %2d.kolumn 1
  while (%2d.rad <= %&stop) {
    while (%2d.kolumn <= %2d.kmax) {
      if ($gettok($read(%2d.map, %2d.rad), %2d.kolumn, 39) != 0) {
        var % $gettok($read(%2d.map, %2d.rad),%2d.kolumn, 39)
        var %fitja $calc(%&start * 64)
        var %q $ffrg($gettok($read(%2d.map, %2d.rad),%2d.kolumn, 39))
        ;2d.vdet
        drawrect -rf @2d.vdet %q 1 $calc((%2d.kolumn * 64) - 64) $calc((%2d.rad * 64) - %fitja) 64 64
        ;2d
        drawcopy @2d.tex $fvgg(%q) 0 64 64 @A3D.bg $calc((%2d.kolumn * 64) - 64) $calc((%2d.rad * 64) - %fitja)
      }
      inc %2d.kolumn 1
    } 
    set %2d.kolumn 1
    inc %2d.rad 1
  }


  ;#2d
  if (%ATTENTAT3D.2d == 1) {
    window -Cpd  @2d 0 0 $calc(%2d.vdet.x + 20) $calc(%2d.vdet.y + 40)
  }

  ;#Attentat 3D
  ;med panel: window -aCp @ATTENTAT3D 0 0 343 309
  window -aCpd @ATTENTAT3D 0 0 343 240

  ;#FPS
  set %2d.fps 0
  set %2d.ticks $ticks
  ;---------------

  2d.init
}

on *:CLOSE:@2d: { set %ATTENTAT3D.2d 0 }
on *:CLOSE:@ATTENTAT3D: {
  .timer001 off
  window -c @2d
  window -c @2d.vdet
  window -c @2d.vggar
  window -c @2d.tex
  window -c @A3D.bg
}


alias 2d.init {
  inc %2d.fps
  if ($timer(001)) { .timer001 off }

  if (%ATTENTAT3d.2d == 1) { clear -n @2d }
  clear -n @ATTENTAT3D
  drawrect -nrf @ATTENTAT3D $rgb(127,127,127) 1 0 0 326 100
  drawrect -nrf @ATTENTAT3D $rgb(210,210,210) 1 0 100 326 100

  if (%ATTENTAT3D.2d == 1) {
    drawrect -rfn @2d $rgb(0,0,0) 1 0 0 %2d.vdet.x %2d.vdet.y
    ;vggar
    drawcopy -n @A3D.bg 0 0 %2d.vdet.x %2d.vdet.y @2d 0 0
    ;spelare
    drawdot -rn @2d $rgb(255,128,0) 8 $calc(%2d.Px + 2) $calc(%2d.Py + 2)
  }

  2d.rays

  ;FPS
  drawtext -rbn @ATTENTAT3D $rgb(252,127,0) $rgb(0,0,0) Verdana 10 2 2 %2d.fps2 FPS

  if (%ATTENTAT3d.2d == 1) { drawdot @2d }

  if (%2d.frruta == 1) {
    drawrect -nrf @ATTENTAT3D $rgb(0,0,0) 1 0 0 326 200
    drawtext -rnc @ATTENTAT3D $rgb(127,127,127) Verdana 17 0 170 ATTENTAT 3D 326 15
    var %y $ceil($calc(($ticks - %2d.frrutaticks) / 1000))
    var %q $+(0.,$gettok($calc(($ticks - %2d.frrutaticks) / 1000), 2, 46))
    var %w $calc(%q * 400)
    var %H $height($abs($calc(%y - 4)),verdana,%w)
    var %T $width($abs($calc(%y - 4)),verdana,%w)
    drawtext -rn @ATTENTAT3D $rgb(127,127,127) Verdana %w $calc((163 - %T / 2)) $calc((100 - %H / 2)) $abs($calc(%y - 4))
  }
  drawdot @ATTENTAT3D

  if  ($calc($ticks - %2d.ticks) >= 1000) {
    set %2d.ticks $ticks
    set %2d.fps2 %2d.fps
    set %2d.fps 0
  }
  .timer001 -m 1 0 2d.init
}
;##################################################################################################





















;##################################  REGISTER  #####################################################################################
alias ffrg {
  if ($1 == 1) { return $rgb(255,0,0) }
  elseif ($1 == 2) { return $rgb(0,255,0) }
  elseif ($1 == 3) { return $rgb(0,0,255) }
  elseif ($1 == 4) { return $rgb(255,0,255) }
  elseif ($1 == 0) { return $rgb(0,0,0) }
}
alias fvgg {
  if ($1 == 255) { return 0 }
  elseif ($1 == 65280) { return 64 }
  elseif ($1 == 16711680) { return 128 }
  elseif ($1 == 16711935) { return 192 }
}
;######################################################################################################################################



















;######################################  Spelar Rrelse #####################################################################################
;37 = Vnster
;39 = Hger
;38 = Fram
;40 = Bak


on *:KEYDOWN:*:37: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    ;vnster 37
    if (!$timer(2d.vrotation)) { .timer2d.vrotation -h 0 200 2d.vrotation }
    set %2d.aold %2d.angle
  }
}
on *:KEYUP:*:37: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    ;vnster 37
    .timer2d.vrotation off
    if (%2d.aold == %2d.angle) {
      inc %2d.angle %2d.zspeed
      if (%2d.angle == 360) {
        set %2d.angle 0
      }
      elseif (%2d.angle > 360) {
        dec %2d.angle 360
      }
    }
  }
}
alias 2d.vrotation {
  inc %2d.angle %2d.zspeed
  if (%2d.angle == 360) {
    set %2d.angle 0
  }
  elseif (%2d.angle > 360) {
    dec %2d.angle 360
  }
}


on *:KEYDOWN:*:39: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    ;hger 39
    if (!$timer(2d.hrotation)) { .timer2d.hrotation -h 0 200 2d.hrotation }
    set %2d.aold %2d.angle
  }
}
on *:KEYUP:*:39: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    ;hger 39
    .timer2d.hrotation off
    if (%2d.aold == %2d.angle) {
      dec %2d.angle %2d.zspeed
      if (%2d.angle < 0) {
        inc %2d.angle 360
      }
    }
  }
}
alias 2d.hrotation {
  dec %2d.angle %2d.zspeed
  if (%2d.angle < 0) {
    inc %2d.angle 360
  }
}


;fram
on *:KEYDOWN:*:38: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    if ($getdot(@2d.vdet,$calc(%2d.Px + (%2d.rspeed * $cos(%2d.angle).deg)),$calc(%2d.Py - (%2d.rspeed * $sin(%2d.angle).deg))) == 0) {
      set %2d.Px $calc(%2d.Px + (%2d.rspeed * $cos(%2d.angle).deg))
      set %2d.Py $calc(%2d.Py - (%2d.rspeed * $sin(%2d.angle).deg))
    }
  }
}


;BAK
on *:KEYDOWN:*:40: {
  if ($active == @ATTENTAT3D) || ($active == @2d) {
    if ($getdot(@2d.vdet,$calc(%2d.Px - (%2d.rspeed * $cos(%2d.angle).deg)),$calc(%2d.Py + (%2d.rspeed * $sin(%2d.angle).deg))) == 0) {
      set %2d.Px $calc(%2d.Px - (%2d.rspeed * $cos(%2d.angle).deg))
      set %2d.Py $calc(%2d.Py + (%2d.rspeed * $sin(%2d.angle).deg))
    }
  }
}
;######################################################################################################################################
















;######################################  Skicka ut strlarna  #########################################################################
alias 2d.rays {

  ;lopoen rr ej
  if (%2d.angle == 330) {
    set %2d.currentrayangle 360
  }
  elseif (%2d.angle >= 330) {
    set %2d.currentrayangle $calc(30 - (360 - %2d.angle))
  }
  else {
    set %2d.currentrayangle $calc(%2d.angle + 30)
  }
  var %i 0
  var %7 $calc(320 / %2d.Q)
  var %8 $calc(%2d.Q * 0.1875)
  while (%i <= %7) {
    ;loopen rr ej



    ;;;;;;;;;;;;;;;;;;;;;;;;;Fr alla andra strlar;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;-------------------------------------- HORISONTELLA BRYTPUNKTER-------------------------------------------
    if (%2d.currentrayangle > 0) && (%2d.currentrayangle < 180) {
      ;?????????????????????????HORISONTELL UPP??????????????????????????????????
      var %890 $floor($calc(%2d.Py / 64))
      set %2d.old.y $calc((%890 * 64) - 1)
      set %2d.rangle $calc(%2d.currentrayangle * $pi / 180)
      set %2d.old.x $calc(%2d.Px + ((%2d.Py - %2d.old.y) / $tan(%2d.rangle)))
      set %2d.Ya -64
      var %891 $calc(%2d.currentrayangle * $pi / 180)
      set %2d.Xa $calc(64 / $tan(%891))
      while ((%2d.old.x >= 0) && (%2d.old.x <= %2d.vdet.mn.x)) && ($getdot(@2d.vdet,%2d.old.x,%2d.old.y) == 0) {
        ;drawdot -nr @2d $rgb(0,255,0) 3 %2d.old.x %2d.old.y
        set %2d.old.x $calc(%2d.old.x + %2d.Xa)
        set %2d.old.y $calc(%2d.old.y + %2d.Ya)
      }
      set %2d.Hx %2d.old.x
      set %2d.Hy %2d.old.y
    }

    elseif (%2d.currentrayangle >= 180) && (%2d.currentrayangle <= 360) {
      ;????????????????????????????HORISONTELL NER??????????????????????????????
      var %890 $floor($calc(%2d.Py / 64))
      set %2d.old.y $calc((%890 * 64) + 64)
      set %2d.rangle $calc(%2d.currentrayangle * $pi / 180)
      set %2d.old.x $calc(%2d.Px + ((%2d.Py - %2d.old.y) / $tan(%2d.rangle)))
      set %2d.Ya 64
      var %890 $calc(%2d.currentrayangle * $pi / 180)
      set %2d.Xa $calc(64 / $tan(%890))
      while ((%2d.old.x >= 0) && (%2d.old.x <= %2d.vdet.mn.x)) && ($getdot(@2d.vdet,%2d.old.x,%2d.old.y) == 0) {
        ;drawdot -nr @2d $rgb(0,255,0) 3 %2d.old.x %2d.old.y
        set %2d.old.x $calc(%2d.old.x - %2d.Xa)
        set %2d.old.y $calc(%2d.old.y + %2d.Ya)
      }
      set %2d.Hx %2d.old.x
      set %2d.Hy %2d.old.y
    }
    ;-----------------------------------------------------------------------------------------------



    ;-------------------------------------- VERTIKALA BRYTPUNKTER-------------------------------------------
    if ((%2d.currentrayangle >= 0) && (%2d.currentrayangle <= 90)) || ((%2d.currentrayangle > 270) && (%2d.currentrayangle <= 360)) {
      ;HGER  VERTIKALER
      var %yyu $floor($calc(%2d.Px / 64))
      var %2d.old.x $calc(%yyu * 64 + 64)
      var %2d.rangle $calc(%2d.currentrayangle * $pi / 180)
      set %2d.old.y $calc(%2d.Py + ((%2d.Px - %2d.old.x) * $tan(%2d.rangle)))
      set %2d.Xa 64
      set %2d.Ya $calc(64 * $tan(%2d.rangle))
      while ((%2d.old.y >= 0) && (%2d.old.y <= %2d.vdet.mn.y)) && ($getdot(@2d.vdet,%2d.old.x,%2d.old.y) == 0) {
        ;drawdot -nr @2d $rgb(0,0,255) 3 %2d.old.x %2d.old.y
        inc %2d.old.x %2d.Xa
        dec %2d.old.y %2d.Ya
      }
      set %2d.Vx %2d.old.x
      set %2d.Vy %2d.old.y
      ;echo -a $getdot(@2d.vdet,%2d.old.x,%2d.old.y)
    }

    elseif ((%2d.currentrayangle > 90) && (%2d.currentrayangle <= 270)) {
      ;VNSTER VERTIKALER
      var %yyu $floor($calc(%2d.Px / 64))
      var %2d.old.x $calc(%yyu * 64 - 1)
      var %2d.rangle $calc(%2d.currentrayangle * $pi / 180)
      set %2d.old.y $calc(%2d.Py + ((%2d.Px - %2d.old.x) * $tan(%2d.rangle)))
      set %2d.Xa 64
      set %2d.Ya $calc(64 * $tan(%2d.rangle))
      while ((%2d.old.y >= 0) && (%2d.old.y <= %2d.vdet.mn.y)) && ($getdot(@2d.vdet,%2d.old.x,%2d.old.y) == 0) {
        ;drawdot -nr @2d $rgb(0,0,255) 3 %2d.old.x %2d.old.y
        dec %2d.old.x %2d.Xa
        inc %2d.old.y %2d.Ya
      }
      set %2d.Vx %2d.old.x
      set %2d.Vy %2d.old.y
    }
    ;-------------------------------------------------------------------------------------------------------
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



    ;------------------------Jmfr horisontell och vertikal distans; vilken r brytpunkt r nrmst spelaren---------------
    var %2d.h $sqrt($calc(((%2d.Px - %2d.Hx)^2) + ((%2d.Py - %2d.Hy)^2)))
    var %2d.v $sqrt($calc(((%2d.Px - %2d.Vx)^2) + ((%2d.Py - %2d.Vy)^2)))
    if (%2d.h > %2d.v) {
      set %2d.vggdistans %2d.v
      set %2d.kub v
      var %2d.vslice $abs($calc(%2d.Vy / 64))
      set %2d.vtex $getdot(@2d.vdet,%2d.Vx,%2d.Vy)
    }
    elseif (%2d.h < %2d.v) {
      set %2d.vggdistans %2d.h
      set %2d.kub h
      var %2d.vslice $abs($calc(%2d.Hx / 64))
      set %2d.vtex $getdot(@2d.vdet,%2d.Hx,%2d.Hy)
    }
    if (%ATTENTAT3D.2d == 1) {
      drawline -rn @2d $rgb(0,0,255) 1 %2d.Px %2d.Py $calc(%2d.Px + (%2d.vggdistans * $cos(%2d.currentrayangle).deg)) $calc(%2d.Py - (%2d.vggdistans * $sin(%2d.currentrayangle).deg))
    }
    ;----------------------------------------------------------------------------------



    ;---------------------------RITA UPP KLUMNERNA = 2d->3D----------------------------
    ;ta bort fishbowl
    set %2d.Beta $abs($calc(%2d.angle - %2d.currentrayangle))
    set %2d.vggdis $calc(%2d.vggdistans * $cos(%2d.beta).deg)

    ;skr ut slice
    var %2d.vgghjd $round($calc((64 / %2d.vggdis) * 277),0)
    var %2d.vgg.y $calc(100 - (%2d.vgghjd / 2))
    var %2d.vgg.x $calc(%i * %2d.Q)
    var %& $+(0.,$gettok(%2d.vslice,2,46))
    ;var % $round($calc(%& * 64),0)
    var % $calc(%& * 64)
    var % $fvgg(%2d.vtex)

    ;korrigera spegelbilds fel
    if (%2d.angle >= 0) && (%2d.angle < 180) {
      if (%2d.kub == h) {
        drawcopy -mn @2d.tex $calc(% + %) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
        if ($calc(% + %2d.Q) > 64) {
          var %? $calc(% - ((% + %2d.Q) - 64))
          drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
        }
      }
      else {
        if (%2d.angle >= 0) && (%2d.angle < 90) {
          drawcopy -mn @2d.tex $calc(% + %) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          if ($calc(% + %2d.Q) > 64) {
            var %? $calc(% - ((% + %2d.Q) - 64))
            drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          }
        }
        elseif (%2d.angle >= 90) && (%2d.angle < 180) {
          var %b $calc(64 - %)
          drawcopy -mn @2d.tex $calc(% + %b) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          if ($calc(%b + %2d.Q) > 64) {
            var %? $calc(%b - ((%b + %2d.Q) - 64))
            drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          }
        }
      }
    }
    elseif (%2d.angle >= 180) && (%2d.angle <= 360) {
      if (%2d.kub == h) {
        var %b $calc(64 - %)
        drawcopy -mn @2d.tex $calc(% + %b) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
        if ($calc(%b + %2d.Q) > 64) {
          var %? $calc(%b - ((%b + %2d.Q) - 64))
          drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
        }
      }
      else {
        if (%2d.angle >= 180) && (%2d.angle < 270) {
          var %b $calc(64 - %)
          drawcopy -mn @2d.tex $calc(% + %b) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          if ($calc(%b + %2d.Q) > 64) {
            var %? $calc(%b - ((%b + %2d.Q) - 64))
            drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          }
        }
        else {
          drawcopy -mn @2d.tex $calc(% + %) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          if ($calc(% + %2d.Q) > 64) {
            var %? $calc(% - ((% + %2d.Q) - 64))
            drawcopy -mn @2d.tex $calc($fvgg(%2d.vtex) + %?) 0 %2d.Q 64 @ATTENTAT3D %2d.vgg.x %2d.vgg.y %2d.Q %2d.vgghjd
          }
        }
      }
    }
    ;----------------------------------------------------------------------------------


    ;loopen rr ej
    dec %2d.currentrayangle %8
    if (%2d.currentrayangle < 0) {
      set %2d.currentrayangle $calc(%2d.currentrayangle + 360)
    }
    inc %i 
  }
  ;loopen rr ej


}
;######################################################################################################################################


















;################################# Dialoger ##############################################################################
;Huvuddialog
alias ATTENTAT3D {
  dialog -dm A3DVM A3DVM
  if (!$1) {
    att.gm
    did -v A3DVM 21-25
    did -c A3DVM 18
  }
  else {
    if ($1 == kr) {
      att.gm
      did -v A3DVM 21-25
    }
    elseif ($1 == inst) {
      att.gm
      did -v A3DVM 1-17
    }
  }
}

;utseende
dialog A3DVM {
  title "ATTENTAT 3D"
  size -1 -1 155 170
  option dbu
  ;MENY
  radio "Run", 18, 7 2 70 15, push
  radio "Options", 19, 81 2 70 15, push
  text "", 20, -2 18 184 5

  ;INSTLLNINGAR
  scroll "", 1, 55 78 78 8, range 2 14 horizontal
  text "Turn speed", 2, 11 79 37 8
  text "Walk speed", 3, 11 97 40 9
  scroll "", 4, 55 98 78 8, range 1 10 horizontal
  button "Close", 5, 111 152 37 12, ok
  button "Preset", 6, 65 152 43 12
  radio "Mone", 7, 16 41 26 10
  radio "Medioker", 8, 57 42 34 10
  radio "High", 9, 108 42 26 10
  box "Quality", 10, 7 30 139 30
  box "Speed", 11, 6 64 139 60
  text "", 12, 11 126 135 20, hide
  text "", 15, 134 77 11 10
  text "", 16, 134 97 10 10
  check "Show 2D", 17, 11 153 50 10

  ;KR
  combo 21, 47 23 104 64, size drop
  text "World:", 22, 9 24 25 8
  text "Description", 23, 9 53 30 8
  text "Desc", 24, 47 54 107 44
  button "Start", 25, 112 150 37 12

  menu "Menu", 13
  item "About", 14, 13
}

;init
on *:dialog:A3DVM:init:0: {
  ;INSTLLNINGAR
  did -c $dname 1 %2d.zspeed
  did -ra $dname 15 %2d.zspeed

  did -c $dname 4 %2d.rspeed
  did -ra $dname 16 %2d.rspeed

  if (%2d.Q == 20) { did -c $dname 7 }
  elseif (%2d.Q == 10) { did -c $dname 8 }
  elseif (%2d.Q == 5) { did -c $dname 9 }

  if (%ATTENTAT3D.2d == 1) { did -c $dname 17 }

  ;KR
  var %m $+(",$scriptdirmap\,")
  var %n $findfile(%m, *.txt, 0)

  var %p 1
  while (%p <= %n) {
    var %o $findfile(%m, *.txt, %p)
    did -a A3DVM 21 $gettok($read($findfile(%m, *.txt, %p), 1), 2, 61)
    set %2d.map $+(",$findfile($scriptdirmap\,*.txt,$readn),")
    inc %p
  }
  did -c A3DVM 21 1
  did -ra A3DVM 24 $gettok($read($findfile(%m, *.txt, $did($dname,21).sel), 2), 2, 61)
}

;skifta mellan Kr och Instllningar
on *:dialog:A3DVM:sclick:18: {
  att.gm
  did -v A3DVM 21-25
}
on *:dialog:A3DVM:sclick:19: {
  att.gm
  did -v A3DVM 1-17
  if (%2d.Q == 20) { did -c $dname 7 }
  elseif (%2d.Q == 10) { did -c $dname 8 }
  elseif (%2d.Q == 5) { did -c $dname 9 }
}

alias att.gm {
  ;dispans: 18,19,20
  ;Kr
  did -h A3DVM 21-25
  ;instllningar
  did -h A3DVM 1-17
}

;INSTLLNINGAR

on *:dialog:A3DVM:mouse:*: {
  if ($did isnum 7-10) {
    if (%2dinst.s != 10) {
      did -vra $dname 12 set how big wallslices should be
      set %2dinst.s 10
    }
  }
  elseif ($did isnum 1-2) {
    if (%2dinst.s != 12) {
      did -vra $dname 12 set the speed of the player turning left/right
      set %2dinst.s 12
    }
  }
  elseif ($did isnum 3-4) {
    if (%2dinst.s != 34) {
      did -vra $dname 12 set players walk speed
      set %2dinst.s 34
    }
  }
  else { did -h $dname 12 | set %2dinst.s 0 }
}
on *:dialog:A3DVM:scroll:*: {
  if ($did == 1) {
    set %2d.zspeed $did($dname,$did).sel
    did -ra $dname 15 %2d.zspeed
  }
  else {
    set %2d.rspeed $did($dname,$did).sel
    did -ra $dname 16 %2d.rspeed
  }
}
on *:dialog:A3DVM:sclick:6: { 2dinst.frinst }
alias 2dinst.frinst {
  did -vra A3DVM 12 preset configurations activated
  set %2d.zspeed 10
  did -c A3DVM 1 %2d.zspeed
  did -ra A3DVM 15 %2d.zspeed

  set %2d.rspeed 10
  did -c A3DVM 4 %2d.rspeed
  did -ra A3DVM 16 %2d.rspeed

  set %2d.Q 5
  did -u A3DVM 7,8,9
  did -c A3DVM 8

  set %ATTENTAT3D.2d 0
  if ($window(@2d)) { window -c @2d }
  did -u A3DVM 17
}
on *:dialog:A3DVM:sclick:7: { set %2d.Q 20 }
on *:dialog:A3DVM:sclick:8: { set %2d.Q 10 }
on *:dialog:A3DVM:sclick:9: { set %2d.Q 5 }
on *:dialog:A3DVM:sclick:17: {
  if (%ATTENTAT3D.2d == 1) {
    set %ATTENTAT3D.2d 0
    if ($window(@2d)) { window -c @2d }
  }
  else {
    if ($window(@ATTENTAT3D)) { window -Cpda @2d 0 0 $calc(%2d.vdet.x + 20) $calc(%2d.vdet.y + 40) | window -a @ATTENTAT3D | set %ATTENTAT3D.2d 1 } 
  }
}

on *:dialog:A3DVM:menu:14: { OA3D }


;KR
on *:dialog:A3DVM:sclick:21: {
  did -ra A3DVM 24 $gettok($read($findfile($scriptdirmap\, *.txt, $did($dname,21).sel), 2), 2, 61)
  set %2d.map $+(",$findfile($scriptdirmap\, *.txt, $did($dname,21).sel),")
}
on *:dialog:A3DVM:sclick:25: {
  ;skicka information
  set %2d.Px $gettok($read(%2d.map, 3), 2, 61)
  set %2d.Py $gettok($read(%2d.map, 4), 2, 61)
  set %2d.angle $gettok($read(%2d.map, 5), 2, 61)

  var %p $read(%2d.map, w, STOP)
  var %pp $readn
  var % $read(%2d.map, w, START)
  var % $readn
  var %u $numtok($read(%2d.map, $calc(% + 1)), 39)
  var %i $calc(%pp - % - 1)
  set %2d.vdet.x $calc(%u * 64)
  set %2d.vdet.y $calc(%i * 64)
  set %2d.vdet.mn.x $calc(%2d.vdet.x - 64)
  set %2d.vdet.mn.y $calc(%2d.vdet.y - 64)

  set %2d.frruta 1
  set %2d.frrutaticks $ticks
  .timer1 1 3 2d.frrutafrsvinn

  dialog -c A3DVM
  attentat3d.go
}
alias 2d.frrutafrsvinn { set %2d.frruta 0 }



;OM
dialog OA3D {
  title "Om ATTENTAT3D"
  size -1 -1 148 144
  option dbu
  text "ATTENTAT 3D", 1, 37 11 69 10, nowrap center
  text "By", 2, 37 23 69 8, center
  text "Hkan Ahlstrm", 3, 37 31 69 8, center
  button "Close", 4, 53 124 37 12, default ok
  text "__________________________________________________________", 5, -7 37 162 12
  text "CREDITS", 6, 44 58 57 11, center
  text "", 7, 44 65 57 11
  text "F.Permadi ToKeN Shahab #HelpDesk #Math", 8, 59 72 25 37, center
}
alias OA3D { dialog -dm OA3D OA3D }

;MENYer
menu @ATTENTAT3D {
  Options:/ATTENTAT3D inst
  2d $iif(!$window(@2d),(OFF),(ON)): {
    if (%ATTENTAT3D.2d == 1) {
      set %ATTENTAT3D.2d 0
      if ($window(@2d)) { window -c @2d }
    }
    else {
      if ($window(@ATTENTAT3D)) { window -Cpda @2d 0 0 $calc(%2d.vdet.x + 20) $calc(%2d.vdet.y + 40) | window -a @ATTENTAT3D | set %ATTENTAT3D.2d 1 } 
    }
  }
  -
  About:/OA3D
}
menu status,menubar {
  ATTENTAT 3D
  .Open:/ATTENTAT3D
  .Options:/ATTENTAT3D inst
  .-
  .About:/OA3D
  .-
  .Uninstall: { .unload -rs %att.avinst }
}
;######################################################################################################################################













;EOF
